# Tmux configuration

My personal tmux configuration. I expect this to evolve over time as I develop my tmux skills.

Made with zsh, oh-my-zsh, p10k, guake and fura code monospace (nerd edition) in mind. Would probably work without (?).

## Changes

The main event right now is the redesigned bottom bar. It boast p10k-look and feel.

![doc/img1.png](doc/img1.png)

Other notable changes are:

- Mouse support enabled. Click to resize panes and switch tabs. (shift+rclick gets you the terminal-native rclick)

- Default shell to zsh

- Prefix key is \` (tilda) (all tmux shortcuts start with this key. Double tap to actually type \`)

## Hotkey cheatsheet

Pretty much all of these are default, except for the fact that they're initiated by tilda instead of ctrl+b.

A lot can also be done using your mouse. Like selecting panes, tabs and resizing.

| Combo             | Details                                                                                                                                                                |
| ----------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `` ` + C``           | Create new tab (tmux window)                                                                                                                                           |
| `` ` + [1..9]`` | Select tab 1 - 9                                                                                                                                                       |
| `` ` + ,``           | Rename tab (tilda+comma)                                                                                                                                               |
| ``  + 🠜🠝🠟🠞``    | Switch panes. You can press the arrow keys in short succession to navigate without hitting ` everytime. After settling your cursor for ~1 second it will 'take effect' |
| `` ` + %``           | Split pane horizontally ---                                                                                                                                            |
| `` ` +  " ``         | Split pane vertically \|                                                                                                                                               |
| `exit`            | exit your terminal, and therefore exit that pane.                                                                                                                      |
| `` ` + ?``           | Open shortcut help in that window                                                                                                                                      |
|                   |                                                                                                                                                                        |
|                   |                                                                                                                                                                        |
|                   |                                                                                                                                                                        |

## Installation

Install tmux from your preferred package repo, then copy .tmux.conf to your home directory. Oneliner:

`wget https://git.thijsdevries.net/dodedodo/tmux.conf/raw/branch/master/.tmux.conf -O ~/.tmux.conf`

**Optionally** you should install zsh and p10k.

1. ```bash
   sh -c "$(curl -fsSL https://raw.github.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"```
   ```

2. ```bash
   git clone --depth=1 https://github.com/romkatv/powerlevel10k.git ~/powerlevel10k
   echo 'source ~/powerlevel10k/powerlevel10k.zsh-theme' >>~/.zshrc
   ```

3. Install nerd-fonts-fira-code (most fira or fura fonts should do the trick, whatever you can lay your hands on)

**'Tested' on**

- manjaro 21.0.4

- gnome 40

- tmux 3.2

- zsh 5.8

- ohmyzsh -

- p10k 1.14.6

- Nerd Fonts: fira code 2.1.0
